Lattice Builder Manual Software Package for Constructing Rank-1 Lattices

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Friends Modules Pages
Classes | Public Types | Public Member Functions | Friends | List of all members
LatBuilder::GenSeq::Extend< TRAV > Class Template Reference

Indexed sequence of integers that extend on an smaller integer by adding higher-order digits. More...

`#include <Extend.h>`

Inherits LatBuilder::Traversal::Policy< Extend< TRAV >, TRAV >.

## Classes
struct | RebindTraversal
| Rebinds the traversal type. More...

## Public Types
typedef Modulus | value_type
| Value type.
typedef size_t | size_type
| Size type.
typedef TRAV | Traversal
| Traversal type.

## Public Member Functions
| Extend (value_type modulus=1, value_type grain=1, value_type low=0, Traversal trav=Traversal())
| Constructor. More...
template<class TRAV2 >
| Extend (const Extend< TRAV2 > &other, Traversal trav=Traversal())
| Cross-traversal copy-constructor.
template<class TRAV2 >
RebindTraversal< TRAV2 >::Type | rebind (TRAV2 trav) const
| Returns a copy of this object, but using a different traversal policy.
value_type | modulus () const
| Returns the modulus.
size_type | size () const
| Returns the size of the sequence. More...
value_type | operator[] (size_type i) const
| Returns the element at index `i`.

## Friends
template<typename >
class | Extend

## Detailed Description

### template<class TRAV = Traversal::Forward>
class LatBuilder::GenSeq::Extend< TRAV >

Indexed sequence of integers that extend on an smaller integer by adding higher-order digits.

Given a small integer \(x\) smaller than the grain \(n_0\), the \(i\)-th integer this sequence is given by \(i n_0 + x\).

Examples:
  tutorial/GenSeqExtend.cc.

## Constructor & Destructor Documentation

template<class TRAV >

LatBuilder::GenSeq::Extend< TRAV >::Extend | ( | value_type | modulus = `1`,
|  | value_type | grain = `1`,
|  | value_type | low = `0`,
|  | Traversal | trav = `Traversal()`
| ) |  |

Constructor.

Parameters

  modulus | All integers in the sequence are smaller than `modulus`.
  grain | Difference between successive integers in the sequence.
  low | j Integer smaller than `grain` that specifies the lower digits of every integer in the sequence.
  trav | Traversal instance.

## Member Function Documentation

template<class TRAV = Traversal::Forward>

size_type LatBuilder::GenSeq::Extend< TRAV >::size | ( |  | ) | const
| inline

Returns the size of the sequence.

The size is the value of Euler's totient function.

The documentation for this class was generated from the following file:

- latbuilder/include/latbuilder/GenSeq/Extend.h